Index: drivers/filesystems/btrfs/btrfs.c
===================================================================
--- drivers/filesystems/btrfs/btrfs.c	(révision 74430)
+++ drivers/filesystems/btrfs/btrfs.c	(copie de travail)
@@ -2867,56 +2695,44 @@
         le = le->Flink;
     }
     
-    ExAcquireResourceSharedLite(&volumes_lock, TRUE);
+    vde = Vcb->vde;
     
-    if (Vcb->devices_loaded < Vcb->superblock.num_devices && !IsListEmpty(&volumes)) {
-        LIST_ENTRY* le = volumes.Flink;
+    ExAcquireResourceSharedLite(&vde->child_lock, TRUE);
+    
+    if (Vcb->devices_loaded < Vcb->superblock.num_devices) {
+        LIST_ENTRY* le = vde->children.Flink;
         
-        while (le != &volumes) {
-            volume* v = CONTAINING_RECORD(le, volume, list_entry);
+        while (le != &vde->children) {
+            volume_child* vc = CONTAINING_RECORD(le, volume_child, list_entry);
             
-            if (RtlCompareMemory(&Vcb->superblock.uuid, &v->fsuuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID) &&
-                RtlCompareMemory(uuid, &v->devuuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID)
-            ) {
-                NTSTATUS Status;
-                PFILE_OBJECT FileObject;
-                PDEVICE_OBJECT DeviceObject;
+            if (RtlCompareMemory(uuid, &vc->uuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID)) {
                 device* dev;
                 
-                Status = IoGetDeviceObjectPointer(&v->devpath, FILE_READ_ATTRIBUTES, &FileObject, &DeviceObject);
-                if (!NT_SUCCESS(Status)) {
-                    ExReleaseResourceLite(&volumes_lock);
-                    ERR("IoGetDeviceObjectPointer(%.*S) returned %08x\n", v->devpath.Length / sizeof(WCHAR), v->devpath.Buffer, Status);
-                    return NULL;
-                }
-                
-                DeviceObject = FileObject->DeviceObject;
-                
-                ObReferenceObject(DeviceObject);
-                ObDereferenceObject(FileObject);
-                
                 dev = ExAllocatePoolWithTag(NonPagedPool, sizeof(device), ALLOC_TAG);
                 if (!dev) {
-                    ExReleaseResourceLite(&volumes_lock);
+                    ExReleaseResourceLite(&vde->child_lock);
                     ERR("out of memory\n");
-                    ObDereferenceObject(DeviceObject);
                     return NULL;
                 }
                 
                 RtlZeroMemory(dev, sizeof(device));
-                dev->devobj = DeviceObject;
+                dev->devobj = vc->devobj;
                 dev->devitem.device_uuid = *uuid;
-                dev->devitem.dev_id = v->devnum;
-                dev->seeding = v->seeding;
+                dev->devitem.dev_id = vc->devid;
+                dev->devitem.num_bytes = vc->size;
+                dev->seeding = vc->seeding;
                 dev->readonly = dev->seeding;
                 dev->reloc = FALSE;
                 dev->removable = FALSE;
-                dev->disk_num = v->disk_num;
-                dev->part_num = v->part_num;
+                dev->disk_num = vc->disk_num;
+                dev->part_num = vc->part_num;
+                dev->num_trim_entries = 0;
+                InitializeListHead(&dev->trim_list);
+                
                 add_device_to_list(Vcb, dev);
                 Vcb->devices_loaded++;
                 
-                ExReleaseResourceLite(&volumes_lock);
+                ExReleaseResourceLite(&vde->child_lock);
                 
                 return dev;
             }
@@ -2925,7 +2741,7 @@
         }
     }
     
-    ExReleaseResourceLite(&volumes_lock);
+    ExReleaseResourceLite(&vde->child_lock);
     
     WARN("could not find device with uuid %02x%02x%02x%02x-%02x%02x-%02x%02x-%02x%02x-%02x%02x%02x%02x%02x%02x\n",
          uuid->uuid[0], uuid->uuid[1], uuid->uuid[2], uuid->uuid[3], uuid->uuid[4], uuid->uuid[5], uuid->uuid[6], uuid->uuid[7],
@@ -2968,27 +2784,17 @@
     return cc;
 }
 
-void init_device(device_extension* Vcb, device* dev, BOOL get_length, BOOL get_nums) {
+void init_device(device_extension* Vcb, device* dev, BOOL get_nums) {
     NTSTATUS Status;
     ULONG aptelen;
     ATA_PASS_THROUGH_EX* apte;
     IDENTIFY_DEVICE_DATA* idd;
+    STORAGE_PROPERTY_QUERY spq;
+    DEVICE_TRIM_DESCRIPTOR dtd;
     
     dev->removable = is_device_removable(dev->devobj);
     dev->change_count = dev->removable ? get_device_change_count(dev->devobj) : 0;
     
-    if (get_length) {
-        GET_LENGTH_INFORMATION gli;
-        
-        Status = dev_ioctl(dev->devobj, IOCTL_DISK_GET_LENGTH_INFO, NULL, 0,
-                           &gli, sizeof(GET_LENGTH_INFORMATION), TRUE, NULL);
-        
-        if (!NT_SUCCESS(Status))
-            ERR("IOCTL_DISK_GET_LENGTH_INFO returned %08x\n", Status);
-        
-        dev->length = gli.Length.QuadPart;
-    }
-    
     if (get_nums) {
         STORAGE_DEVICE_NUMBER sdn;
         
@@ -2997,8 +2803,8 @@
         
         if (!NT_SUCCESS(Status)) {
             WARN("IOCTL_STORAGE_GET_DEVICE_NUMBER returned %08x\n", Status);
-            dev->disk_num = 0;
-            dev->part_num = 0;
+            dev->disk_num = 0xffffffff;
+            dev->part_num = 0xffffffff;
         } else {
             dev->disk_num = sdn.DeviceNumber;
             dev->part_num = sdn.PartitionNumber;
@@ -3005,10 +2811,12 @@
         }
     }
     
-    dev->ssd = FALSE;
     dev->trim = FALSE;
     dev->readonly = dev->seeding;
     dev->reloc = FALSE;
+    dev->num_trim_entries = 0;
+    dev->stats_changed = FALSE;
+    InitializeListHead(&dev->trim_list);
     
     if (!dev->readonly) {
         Status = dev_ioctl(dev->devobj, IOCTL_DISK_IS_WRITABLE, NULL, 0,
@@ -3031,7 +2839,7 @@
     apte->DataTransferLength = aptelen - sizeof(ATA_PASS_THROUGH_EX);
     apte->TimeOutValue = 3;
     apte->DataBufferOffset = apte->Length;
-    apte->CurrentTaskFile[6] = 0xec; // IDENTIFY DEVICE
+    apte->CurrentTaskFile[6] = IDE_COMMAND_IDENTIFY;
     
     Status = dev_ioctl(dev->devobj, IOCTL_ATA_PASS_THROUGH, apte, aptelen,
                        apte, aptelen, TRUE, NULL);
@@ -3041,15 +2849,24 @@
     else {
         idd = (IDENTIFY_DEVICE_DATA*)((UINT8*)apte + sizeof(ATA_PASS_THROUGH_EX));
         
-        if (idd->NominalMediaRotationRate == 1) {
-            dev->ssd = TRUE;
-            TRACE("device identified as SSD\n");
-        } else if (idd->NominalMediaRotationRate == 0)
-            TRACE("no rotational speed returned, assuming not SSD\n");
-        else
-            TRACE("rotational speed of %u RPM\n", idd->NominalMediaRotationRate);
-        
-        if (idd->DataSetManagementFeature.SupportsTrim) {
+        if (idd->CommandSetSupport.FlushCache) {
+            dev->can_flush = TRUE;
+            TRACE("FLUSH CACHE supported\n");
+        } else
+            TRACE("FLUSH CACHE not supported\n");
+    }
+    
+    ExFreePool(apte);
+    
+    spq.PropertyId = StorageDeviceTrimProperty;
+    spq.QueryType = PropertyStandardQuery;
+    spq.AdditionalParameters[0] = 0;
+    
+    Status = dev_ioctl(dev->devobj, IOCTL_STORAGE_QUERY_PROPERTY, &spq, sizeof(STORAGE_PROPERTY_QUERY),
+                       &dtd, sizeof(DEVICE_TRIM_DESCRIPTOR), TRUE, NULL);
+    
+    if (NT_SUCCESS(Status)) {
+        if (dtd.TrimEnabled) {
             dev->trim = TRUE;
             Vcb->trim = TRUE;
             TRACE("TRIM supported\n");
@@ -3057,7 +2874,7 @@
             TRACE("TRIM not supported\n");
     }
     
-    ExFreePool(apte);
+    RtlZeroMemory(dev->stats, sizeof(UINT64) * 5);
 }
 
 static NTSTATUS STDCALL load_chunk_root(device_extension* Vcb, PIRP Irp) {
@@ -3100,7 +2917,7 @@
                         RtlCopyMemory(&dev->devitem, tp.item->data, min(tp.item->size, sizeof(DEV_ITEM)));
                         
                         if (le != Vcb->devices.Flink)
-                            init_device(Vcb, dev, TRUE, TRUE);
+                            init_device(Vcb, dev, TRUE);
                         
                         done = TRUE;
                         break;
@@ -3110,49 +2927,42 @@
                 }
                 
                 if (!done) {
-                    ExAcquireResourceSharedLite(&volumes_lock, TRUE);
+                    volume_device_extension* vde = Vcb->vde;
                     
-                    if (!IsListEmpty(&volumes) && Vcb->devices_loaded < Vcb->superblock.num_devices) {
-                        LIST_ENTRY* le = volumes.Flink;
+                    ExAcquireResourceSharedLite(&vde->child_lock, TRUE);
+                    
+                    if (Vcb->devices_loaded < Vcb->superblock.num_devices) {
+                        LIST_ENTRY* le = vde->children.Flink;
                         
-                        while (le != &volumes) {
-                            volume* v = CONTAINING_RECORD(le, volume, list_entry);
+                        while (le != &vde->children) {
+                            volume_child* vc = CONTAINING_RECORD(le, volume_child, list_entry);
             
-                            if (RtlCompareMemory(&di->device_uuid, &v->devuuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID)) {
-                                PFILE_OBJECT FileObject;
-                                PDEVICE_OBJECT DeviceObject;
+                            if (RtlCompareMemory(&di->device_uuid, &vc->uuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID)) {
                                 device* dev;
-                                
-                                Status = IoGetDeviceObjectPointer(&v->devpath, FILE_READ_DATA | FILE_WRITE_DATA, &FileObject, &DeviceObject);
-                                if (!NT_SUCCESS(Status)) {
-                                    ExReleaseResourceLite(&volumes_lock);
-                                    ERR("IoGetDeviceObjectPointer(%.*S) returned %08x\n", v->devpath.Length / sizeof(WCHAR), v->devpath.Buffer, Status);
-                                    return Status;
-                                }
-                                
-                                DeviceObject = FileObject->DeviceObject;
-                                
-                                ObReferenceObject(DeviceObject);
-                                ObDereferenceObject(FileObject);
-                                
+
                                 dev = ExAllocatePoolWithTag(NonPagedPool, sizeof(device), ALLOC_TAG);
                                 if (!dev) {
-                                    ExReleaseResourceLite(&volumes_lock);
+                                    ExReleaseResourceLite(&vde->child_lock);
                                     ERR("out of memory\n");
-                                    ObDereferenceObject(DeviceObject);
                                     return STATUS_INSUFFICIENT_RESOURCES;
                                 }
                                 
                                 RtlZeroMemory(dev, sizeof(device));
                                
-                                dev->devobj = DeviceObject;
+                                dev->devobj = vc->devobj;
                                 RtlCopyMemory(&dev->devitem, di, min(tp.item->size, sizeof(DEV_ITEM)));
-                                dev->seeding = v->seeding;
-                                init_device(Vcb, dev, FALSE, FALSE);
+                                dev->seeding = vc->seeding;
+                                init_device(Vcb, dev, FALSE);
 
-                                dev->length = v->length;
-                                dev->disk_num = v->disk_num;
-                                dev->part_num = v->part_num;
+                                if (dev->devitem.num_bytes > vc->size) {
+                                    WARN("device %llx: DEV_ITEM says %llx bytes, but Windows only reports %llx\n", tp.item->key.offset,
+                                         dev->devitem.num_bytes, vc->size);
+
+                                    dev->devitem.num_bytes = vc->size;
+                                }
+
+                                dev->disk_num = vc->disk_num;
+                                dev->part_num = vc->part_num;
                                 add_device_to_list(Vcb, dev);
                                 Vcb->devices_loaded++;
 
@@ -3171,7 +2981,7 @@
                     } else
                         ERR("unexpected device %llx found\n", tp.item->key.offset);
                     
-                    ExReleaseResourceLite(&volumes_lock);
+                    ExReleaseResourceLite(&vde->child_lock);
                 }
             }
         } else if (tp.item->key.obj_type == TYPE_CHUNK_ITEM) {
@@ -3188,10 +2998,11 @@
                 c->size = tp.item->size;
                 c->offset = tp.item->key.offset;
                 c->used = c->oldused = 0;
-                c->cache = NULL;
+                c->cache = c->old_cache = NULL;
                 c->created = FALSE;
                 c->readonly = FALSE;
                 c->reloc = FALSE;
+                c->cache_loaded = FALSE;
                 
                 c->chunk_item = ExAllocatePoolWithTag(NonPagedPool, tp.item->size, ALLOC_TAG);
                 
@@ -3212,6 +3023,9 @@
                 if (c->chunk_item->type & BLOCK_FLAG_SYSTEM && c->chunk_item->type > Vcb->system_flags)
                     Vcb->system_flags = c->chunk_item->type;
                 
+                if (c->chunk_item->type & BLOCK_FLAG_RAID10 && c->chunk_item->sub_stripes == 0)
+                    c->chunk_item->sub_stripes = 1; // avoid potential division by zero
+                
                 if (c->chunk_item->num_stripes > 0) {
                     CHUNK_ITEM_STRIPE* cis = (CHUNK_ITEM_STRIPE*)&c->chunk_item[1];
                     UINT16 i;
@@ -3251,10 +3065,12 @@
                 InitializeListHead(&c->changed_extents);
                 
                 InitializeListHead(&c->range_locks);
-                KeInitializeSpinLock(&c->range_locks_spinlock);
+                ExInitializeResourceLite(&c->range_locks_lock);
                 KeInitializeEvent(&c->range_locks_event, NotificationEvent, FALSE);
                 
                 c->last_alloc_set = FALSE;
+                
+                c->last_stripe = 0;
 
                 InsertTailList(&Vcb->chunks, &c->list_entry);
                 
@@ -3331,17 +3147,18 @@
                 }
             }
         } else if (ci->type & BLOCK_FLAG_RAID5) {
+            UINT64 stripe_size = ci->size / (ci->num_stripes - 1);
+            
             for (j = 0; j < ci->num_stripes; j++) {
-                UINT64 stripe_size = ci->size / (ci->num_stripes - 1);
-                
                 if (cis[j].offset + stripe_size > superblock_addrs[i] && cis[j].offset <= superblock_addrs[i] + sizeof(superblock)) {
                     TRACE("cut out superblock in chunk %llx\n", c->offset);
                     
                     off_start = superblock_addrs[i] - cis[j].offset;
-                    off_start -= off_start % (ci->stripe_length * (ci->num_stripes - 1));
+                    off_start -= off_start % ci->stripe_length;
                     off_start *= ci->num_stripes - 1;
 
-                    off_end = off_start + (ci->stripe_length * (ci->num_stripes - 1));
+                    off_end = sector_align(superblock_addrs[i] - cis[j].offset + sizeof(superblock), ci->stripe_length);
+                    off_end *= ci->num_stripes - 1;
                     
                     TRACE("cutting out %llx, size %llx\n", c->offset + off_start, off_end - off_start);
 
@@ -3349,17 +3166,18 @@
                 }
             }
         } else if (ci->type & BLOCK_FLAG_RAID6) {
+            UINT64 stripe_size = ci->size / (ci->num_stripes - 2);
+            
             for (j = 0; j < ci->num_stripes; j++) {
-                UINT64 stripe_size = ci->size / (ci->num_stripes - 2);
-                
                 if (cis[j].offset + stripe_size > superblock_addrs[i] && cis[j].offset <= superblock_addrs[i] + sizeof(superblock)) {
                     TRACE("cut out superblock in chunk %llx\n", c->offset);
                     
                     off_start = superblock_addrs[i] - cis[j].offset;
-                    off_start -= off_start % (ci->stripe_length * (ci->num_stripes - 2));
+                    off_start -= off_start % ci->stripe_length;
                     off_start *= ci->num_stripes - 2;
 
-                    off_end = off_start + (ci->stripe_length * (ci->num_stripes - 2));
+                    off_end = sector_align(superblock_addrs[i] - cis[j].offset + sizeof(superblock), ci->stripe_length);
+                    off_end *= ci->num_stripes - 2;
                     
                     TRACE("cutting out %llx, size %llx\n", c->offset + off_start, off_end - off_start);
 
@@ -3420,23 +3238,6 @@
             }
         }
 
-        if (!Vcb->readonly) {
-            // It doesn't make a great deal of sense to load the free space cache of a
-            // readonly seeding chunk, as we'll never write to it. But btrfs check will
-            // complain if we don't write a valid cache, so we have to do it anyway...
-                
-            // FIXME - make sure we free occasionally after doing one of these, or we
-            // might use up a lot of memory with a big disk.
-            
-            Status = load_free_space_cache(Vcb, c, Irp);
-            if (!NT_SUCCESS(Status)) {
-                ERR("load_free_space_cache returned %08x\n", Status);
-                return Status;
-            }
-            
-            protect_superblocks(Vcb, c);
-        }
-
         le = le->Flink;
     }
     
@@ -3683,41 +3484,213 @@
     return STATUS_SUCCESS;
 }
 
-static BOOL raid_generations_okay(device_extension* Vcb) {
-    LIST_ENTRY* le2;
+static BOOL is_btrfs_volume(PDEVICE_OBJECT DeviceObject) {
+    NTSTATUS Status;
+    MOUNTDEV_NAME mdn, *mdn2;
+    ULONG mdnsize;
     
-    // FIXME - if the difference between superblocks is small, we should try to recover
+    Status = dev_ioctl(DeviceObject, IOCTL_MOUNTDEV_QUERY_DEVICE_NAME, NULL, 0, &mdn, sizeof(MOUNTDEV_NAME), TRUE, NULL);
+    if (!NT_SUCCESS(Status) && Status != STATUS_BUFFER_OVERFLOW) {
+        ERR("IOCTL_MOUNTDEV_QUERY_DEVICE_NAME returned %08x\n", Status);
+        return FALSE;
+    }
     
-    le2 = Vcb->devices.Flink;
-    while (le2 != &Vcb->devices) {
-        LIST_ENTRY* le;
-        device* dev = CONTAINING_RECORD(le2, device, list_entry);
+    mdnsize = offsetof(MOUNTDEV_NAME, Name[0]) + mdn.NameLength;
+    
+    mdn2 = ExAllocatePoolWithTag(PagedPool, mdnsize, ALLOC_TAG);
+    if (!mdn2) {
+        ERR("out of memory\n");
+        return FALSE;
+    }
+    
+    Status = dev_ioctl(DeviceObject, IOCTL_MOUNTDEV_QUERY_DEVICE_NAME, NULL, 0, mdn2, mdnsize, TRUE, NULL);
+    if (!NT_SUCCESS(Status)) {
+        ERR("IOCTL_MOUNTDEV_QUERY_DEVICE_NAME returned %08x\n", Status);
+        ExFreePool(mdn2);
+        return FALSE;
+    }
+    
+    if (mdn2->NameLength > wcslen(BTRFS_VOLUME_PREFIX) * sizeof(WCHAR) &&
+        RtlCompareMemory(mdn2->Name, BTRFS_VOLUME_PREFIX, wcslen(BTRFS_VOLUME_PREFIX) * sizeof(WCHAR)) == wcslen(BTRFS_VOLUME_PREFIX) * sizeof(WCHAR)) {
+        ExFreePool(mdn2);
+        return TRUE;
+    }
+    
+    ExFreePool(mdn2);
+    
+    return FALSE;
+}
+
+static NTSTATUS get_device_pnp_name_guid(PDEVICE_OBJECT DeviceObject, PUNICODE_STRING pnp_name, const GUID* guid) {
+    NTSTATUS Status;
+    WCHAR *list = NULL, *s;
+    
+    Status = IoGetDeviceInterfaces((PVOID)guid, NULL, 0, &list);
+    if (!NT_SUCCESS(Status)) {
+        ERR("IoGetDeviceInterfaces returned %08x\n", Status);
+        return Status;
+    }
+    
+    s = list;
+    while (s[0] != 0) {
+        PFILE_OBJECT FileObject;
+        PDEVICE_OBJECT devobj;
+        UNICODE_STRING name;
         
-        ExAcquireResourceSharedLite(&volumes_lock, TRUE);
+        name.Length = name.MaximumLength = wcslen(s) * sizeof(WCHAR);
+        name.Buffer = s;
         
-        le = volumes.Flink;
-        
-        while (le != &volumes) {
-            volume* v = CONTAINING_RECORD(le, volume, list_entry);
+        if (NT_SUCCESS(IoGetDeviceObjectPointer(&name, FILE_READ_ATTRIBUTES, &FileObject, &devobj))) {
+            if (DeviceObject == devobj || DeviceObject == FileObject->DeviceObject) {
+                ObDereferenceObject(FileObject);
+                
+                pnp_name->Buffer = ExAllocatePoolWithTag(PagedPool, name.Length, ALLOC_TAG);
+                if (!pnp_name->Buffer) {
+                    ERR("out of memory\n");
+                    Status = STATUS_INSUFFICIENT_RESOURCES;
+                    goto end;
+                }
+                
+                RtlCopyMemory(pnp_name->Buffer, name.Buffer, name.Length);
+                pnp_name->Length = pnp_name->MaximumLength = name.Length;
+                
+                Status = STATUS_SUCCESS;
+                goto end;
+            }
             
-            if (RtlCompareMemory(&Vcb->superblock.uuid, &v->fsuuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID) &&
-                RtlCompareMemory(&dev->devitem.device_uuid, &v->devuuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID)
-            ) {
-                if (v->gen1 != Vcb->superblock.generation - 1) {
-                    WARN("device %llu had generation %llx, expected %llx\n", dev->devitem.dev_id, v->gen1, Vcb->superblock.generation - 1);
-                    ExReleaseResourceLite(&volumes_lock);
-                    return FALSE;
-                } else
-                    break;
-            }
-            le = le->Flink;
+            ObDereferenceObject(FileObject);
         }
         
-        ExReleaseResourceLite(&volumes_lock);
+        s = &s[wcslen(s) + 1];
+    }
+    
+    pnp_name->Length = pnp_name->MaximumLength = 0;
+    pnp_name->Buffer = 0;
+    
+    Status = STATUS_NOT_FOUND;
+    
+end:
+    if (list)
+        ExFreePool(list);
+    
+    return Status;
+}
+
+NTSTATUS get_device_pnp_name(PDEVICE_OBJECT DeviceObject, PUNICODE_STRING pnp_name, const GUID** guid) {
+    NTSTATUS Status;
+    
+    Status = get_device_pnp_name_guid(DeviceObject, pnp_name, &GUID_DEVINTERFACE_VOLUME);
+    if (NT_SUCCESS(Status)) {
+        *guid = &GUID_DEVINTERFACE_VOLUME;
+        return Status;
+    }
+    
+    Status = get_device_pnp_name_guid(DeviceObject, pnp_name, &GUID_DEVINTERFACE_HIDDEN_VOLUME);
+    if (NT_SUCCESS(Status)) {
+        *guid = &GUID_DEVINTERFACE_HIDDEN_VOLUME;
+        return Status;
+    }
+    
+    Status = get_device_pnp_name_guid(DeviceObject, pnp_name, &GUID_DEVINTERFACE_DISK);
+    if (NT_SUCCESS(Status)) {
+        *guid = &GUID_DEVINTERFACE_DISK;
+        return Status;
+    }
+    
+    return STATUS_NOT_FOUND;
+}
+
+static NTSTATUS check_mount_device(PDEVICE_OBJECT DeviceObject) {
+    NTSTATUS Status;
+    ULONG to_read;
+    superblock* sb;
+    UINT32 crc32;
+    UNICODE_STRING pnp_name;
+    const GUID* guid;
+    
+    to_read = DeviceObject->SectorSize == 0 ? sizeof(superblock) : sector_align(sizeof(superblock), DeviceObject->SectorSize);
+    
+    sb = ExAllocatePoolWithTag(NonPagedPool, to_read, ALLOC_TAG);
+    if (!sb) {
+        ERR("out of memory\n");
+        return STATUS_INSUFFICIENT_RESOURCES;
+    }
+    
+    Status = sync_read_phys(DeviceObject, superblock_addrs[0], to_read, (PUCHAR)sb, FALSE);
+    if (!NT_SUCCESS(Status)) {
+        ERR("sync_read_phys returned %08x\n", Status);
+        goto end;
+    }
+
+    if (sb->magic != BTRFS_MAGIC) {
+        Status = STATUS_SUCCESS;
+        goto end;
+    }
+    
+    crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&sb->uuid, (ULONG)sizeof(superblock) - sizeof(sb->checksum));
         
-        le2 = le2->Flink;
+    if (crc32 != *((UINT32*)sb->checksum)) {
+        WARN("crc32 was %08x, expected %08x\n", crc32, *((UINT32*)sb->checksum));
+        Status = STATUS_SUCCESS;
+        goto end;
     }
     
+    Status = get_device_pnp_name(DeviceObject, &pnp_name, &guid);
+    if (!NT_SUCCESS(Status)) {
+        ERR("get_device_pnp_name returned %08x\n", Status);
+        goto end;
+    }
+    
+    if (pnp_name.Length == 0)
+        goto end;
+    
+    volume_arrival(drvobj, &pnp_name);
+    
+    ExFreePool(pnp_name.Buffer);
+
+end:
+    ExFreePool(sb);
+    
+    return Status;
+}
+
+static BOOL still_has_superblock(PDEVICE_OBJECT device) {
+    NTSTATUS Status;
+    ULONG to_read;
+    superblock* sb;
+    
+    to_read = device->SectorSize == 0 ? sizeof(superblock) : sector_align(sizeof(superblock), device->SectorSize);
+    
+    sb = ExAllocatePoolWithTag(NonPagedPool, to_read, ALLOC_TAG);
+    if (!sb) {
+        ERR("out of memory\n");
+        return FALSE;
+    }
+    
+    Status = sync_read_phys(device, superblock_addrs[0], to_read, (PUCHAR)sb, TRUE);
+    if (!NT_SUCCESS(Status)) {
+        ERR("Failed to read superblock: %08x\n", Status);
+        ExFreePool(sb);
+        return FALSE;
+    }
+    
+    if (sb->magic != BTRFS_MAGIC) {
+        TRACE("not a BTRFS volume\n");
+        ExFreePool(sb);
+        return FALSE;
+    } else {
+        UINT32 crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&sb->uuid, (ULONG)sizeof(superblock) - sizeof(sb->checksum));
+        
+        if (crc32 != *((UINT32*)sb->checksum)) {
+            WARN("crc32 was %08x, expected %08x\n", crc32, *((UINT32*)sb->checksum));
+            ExFreePool(sb);
+            return FALSE;
+        }
+    }
+    
+    device->Flags &= ~DO_VERIFY_VOLUME;
+    
+    ExFreePool(sb);
     return TRUE;
 }
 
@@ -3727,7 +3700,6 @@
     PDEVICE_OBJECT DeviceToMount;
     NTSTATUS Status;
     device_extension* Vcb = NULL;
-    GET_LENGTH_INFORMATION gli;
     LIST_ENTRY *le, batchlist;
     KEY searchkey;
     traverse_ptr tp;
@@ -3735,6 +3707,8 @@
     ccb* root_ccb = NULL;
     BOOL init_lookaside = FALSE;
     device* dev;
+    volume_device_extension* vde;
+    volume_child* vc;
     
     TRACE("(%p, %p)\n", DeviceObject, Irp);
     
@@ -3745,13 +3719,63 @@
 
     IrpSp = IoGetCurrentIrpStackLocation(Irp);
     DeviceToMount = IrpSp->Parameters.MountVolume.DeviceObject;
+    
+    if (!is_btrfs_volume(DeviceToMount)) {
+        Status = check_mount_device(DeviceToMount);
+        if (!NT_SUCCESS(Status))
+            WARN("check_mount_device returned %08x\n", Status);
 
-    Status = dev_ioctl(DeviceToMount, IOCTL_DISK_GET_LENGTH_INFO, NULL, 0, &gli, sizeof(gli), TRUE, NULL);
-    if (!NT_SUCCESS(Status)) {
-        ERR("error reading length information: %08x\n", Status);
         Status = STATUS_UNRECOGNIZED_VOLUME;
+        goto exit2;
+    }
+    
+    vde = DeviceToMount->DeviceExtension;
+    
+    if (!vde || vde->type != VCB_TYPE_VOLUME) {
+        Status = STATUS_UNRECOGNIZED_VOLUME;
+        goto exit2;
+    }
+    
+    ExAcquireResourceExclusiveLite(&vde->child_lock, TRUE);
+    
+    le = vde->children.Flink;
+    while (le != &vde->children) {
+        LIST_ENTRY* le2 = le->Flink;
+        
+        vc = CONTAINING_RECORD(vde->children.Flink, volume_child, list_entry);
+        
+        if (!still_has_superblock(vc->devobj)) {
+            remove_volume_child(vde, vc, TRUE);
+            
+            if (vde->num_children == 0) {
+                ERR("error - number of devices is zero\n");
+                Status = STATUS_INTERNAL_ERROR;
+                goto exit2;
+            }
+            
+            if (vde->children_loaded == 0) { // just removed last device
+                Status = STATUS_DEVICE_NOT_READY;
+                goto exit2;
+            }
+        }
+        
+        le = le2;
+    }
+    
+    if (vde->children_loaded < vde->num_children) { // devices missing
+        Status = STATUS_DEVICE_NOT_READY;
         goto exit;
     }
+    
+    if (vde->num_children == 0) {
+        ERR("error - number of devices is zero\n");
+        Status = STATUS_INTERNAL_ERROR;
+        goto exit;
+    }
+    
+    ExConvertExclusiveToSharedLite(&vde->child_lock);
+    
+    vc = CONTAINING_RECORD(vde->children.Flink, volume_child, list_entry);
 
     Status = IoCreateDevice(drvobj, sizeof(device_extension), NULL, FILE_DEVICE_DISK_FILE_SYSTEM, 0, FALSE, &NewDeviceObject);
     if (!NT_SUCCESS(Status)) {
@@ -3761,9 +3785,15 @@
     }
     
     NewDeviceObject->Flags |= DO_DIRECT_IO;
+    
+    // Some programs seem to expect that the sector size will be 512, for
+    // FILE_NO_INTERMEDIATE_BUFFERING and the like.
+    NewDeviceObject->SectorSize = min(DeviceToMount->SectorSize, 512);
+    
     Vcb = (PVOID)NewDeviceObject->DeviceExtension;
     RtlZeroMemory(Vcb, sizeof(device_extension));
-    Vcb->type = VCB_TYPE_VOLUME;
+    Vcb->type = VCB_TYPE_FS;
+    Vcb->vde = vde;
     
     ExInitializeResourceLite(&Vcb->tree_lock);
     Vcb->open_trees = 0;
@@ -3771,15 +3801,16 @@
 
     ExInitializeResourceLite(&Vcb->fcb_lock);
     ExInitializeResourceLite(&Vcb->chunk_lock);
+    ExInitializeResourceLite(&Vcb->dirty_fcbs_lock);
+    ExInitializeResourceLite(&Vcb->dirty_filerefs_lock);
+    ExInitializeResourceLite(&Vcb->scrub.stats_lock);
 
     ExInitializeResourceLite(&Vcb->load_lock);
     ExAcquireResourceExclusiveLite(&Vcb->load_lock, TRUE);
 
     DeviceToMount->Flags |= DO_DIRECT_IO;
-    
-    TRACE("partition length = %llx\n", gli.Length.QuadPart);
 
-    Status = read_superblock(Vcb, DeviceToMount, gli.Length.QuadPart);
+    Status = read_superblock(Vcb, vc->devobj, vc->size);
     if (!NT_SUCCESS(Status)) {
         Status = STATUS_UNRECOGNIZED_VOLUME;
         goto exit;
@@ -3803,24 +3834,6 @@
         goto exit;
     }
     
-    ExAcquireResourceSharedLite(&volumes_lock, TRUE);
-    
-    le = volumes.Flink;
-    while (le != &volumes) {
-        volume* v = CONTAINING_RECORD(le, volume, list_entry);
-        
-        if (RtlCompareMemory(&Vcb->superblock.uuid, &v->fsuuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID) && v->devnum < Vcb->superblock.dev_item.dev_id) {
-            // skipping over device in RAID which isn't the first one
-            ExReleaseResourceLite(&volumes_lock);
-            Status = STATUS_UNRECOGNIZED_VOLUME;
-            goto exit;
-        }
-        
-        le = le->Flink;
-    }
-    
-    ExReleaseResourceLite(&volumes_lock);
-    
     Vcb->readonly = FALSE;
     if (Vcb->superblock.compat_ro_flags & ~COMPAT_RO_SUPPORTED) {
         WARN("mounting read-only because of unsupported flags (%llx)\n", Vcb->superblock.compat_ro_flags & ~COMPAT_RO_SUPPORTED);
@@ -3841,13 +3854,19 @@
         goto exit;
     }
     
-    dev->devobj = DeviceToMount;
+    dev->devobj = vc->devobj;
     RtlCopyMemory(&dev->devitem, &Vcb->superblock.dev_item, sizeof(DEV_ITEM));
     
+    if (dev->devitem.num_bytes > vc->size) {
+        WARN("device %llx: DEV_ITEM says %llx bytes, but Windows only reports %llx\n", dev->devitem.dev_id,
+                dev->devitem.num_bytes, vc->size);
+
+        dev->devitem.num_bytes = vc->size;
+    }
+    
     dev->seeding = Vcb->superblock.flags & BTRFS_SUPERBLOCK_FLAGS_SEEDING ? TRUE : FALSE;
     
-    init_device(Vcb, dev, FALSE, TRUE);
-    dev->length = gli.Length.QuadPart;
+    init_device(Vcb, dev, TRUE);
     
     InsertTailList(&Vcb->devices, &dev->list_entry);
     Vcb->devices_loaded = 1;
@@ -3866,7 +3885,7 @@
     
     Vcb->log_to_phys_loaded = FALSE;
     
-    add_root(Vcb, BTRFS_ROOT_CHUNK, Vcb->superblock.chunk_tree_addr, NULL);
+    add_root(Vcb, BTRFS_ROOT_CHUNK, Vcb->superblock.chunk_tree_addr, Vcb->superblock.chunk_root_generation, NULL);
     
     if (!Vcb->chunk_root) {
         ERR("Could not load chunk root.\n");
